import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

/*
 * Essa classe utiliza a ActionListenerAdapter para tratar os eventos do botao meuJButton.
 * Ela nao eh um ActionListener. 
 */
public class GUIDemo extends JFrame { // implements ActionListener{
	protected int numCl = 0;
	protected JButton meuJButton = null;
	protected JLabel meuJLabel = null;

	public GUIDemo(String title) {
		super(title);
		initialize();
	}

	public GUIDemo() {
		this("Demonstrando eventos");
	}

	protected void initialize() {
		this.setSize(new Dimension(200, 75));
		meuJButton = new JButton("Clique em mim!");

		meuJLabel = new JLabel("Num. clicks=" + numCl);

		/*
		 * descomentarmos a linha abaixo, fazermos essa classe implementar a
		 * inteface ActionListener e implmentar o metodo actionPerformed (da
		 * interface ActionListener)  outra forma de fazer com que os eventos
		 * de acao dos componentes dessa classe sejam tratados.
		 */
		// meuJButton.addActionListener(this);
		meuJButton.addActionListener(new ActionListenerAdapter(meuJLabel));

		this.getContentPane().add(meuJButton, BorderLayout.NORTH);
		this.getContentPane().add(meuJLabel, BorderLayout.SOUTH);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.pack();
		this.setVisible(true);
	}

	/*
	 * Metodo a ser implementado por todo objeto que implementa a interface
	 * ActionListener
	 */
	// public void actionPerformed(ActionEvent e) {
	// numCl++;
	// meuJLabel.setText("Num Clicks:"+numCl);
	// }
	public static void main(String args[]) {
		new GUIDemo("Evento ActionPerformed");
	}

}
